#include <stdio.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/iocan128.h>
#include <avr/iocanxx.h>
#include <avr/signal.h>
#include "Can.h"
#define NOMOB   0xFF
extern char *last_can_message;
extern volatile int can_receive_flag;
uint8_t mob;
uint8_t h_data[10];
void Init(void)
{
	CANGCON |= (1<<SWRES);                          // CAN: Reset
	CANGCON &= ~(1<<SWRES); 
	CANGIE= (1<<ENIT) | (1<<ENBOFF) |(1<<ENRX) |(1<<ENTX) |(1<<ENERR)|(1<<ENBX)|(1<<ENERG)|(0<<ENOVRT); //set CAN general interrupt
	/* enable Interrupt of MOB0    */
	CANIE2 |= 0xFF;  
	CANIE1 |= 0xFF;                      

	
	for (int mob = 0; mob < 15; mob++)       // clear all  MOBs
	{	
		CANPAGE  = (mob << MOBNB0);     //clear page number in Register
		CANSTMOB = 0x00;               //clear  MOB status Register-
		CANCDMOB = 0x00;               //clear MOB kontrol
		CANGSTA = 0x00;                //clear CAN generalstatus
		CANIDT1 = 0x00;                //clear Identifier Tag Register1
		CANIDT2 = 0x00;                //clear Identifier Tag Register2
		CANIDT3 = 0x00;                //clear Identifier Tag Register3
		CANIDT4 = 0x00;                //clear Identifier Tag Register4
		CANIDM4=  0x00;                //clear Identifier Mask Register1
		CANIDM3=  0x00;                //clear Identifier Mask Register2
		CANIDM2=  0x00;                //clear Identifier Mask Register3
		CANIDM1=  0x00;                //clear Identifier Mask Register4
		
		for (unsigned char j=0; j<8; j++) 
		{	
			CANMSG=0;       //clear all CAN Message Register
		}

	}
	CANPAGE  = 0 << MOBNB0; 
	CANBT1= (1<<BRP0);                              // set CAN Baudrate Register1
	CANBT2= (4<<PRS0) | (0<<SJW0);                  // set CAN Baurate Rgister2
	CANBT3= (1<<PHS20) | (1<<PHS10);               // set CAN Baurate Rgister3
	CANGCON |= (1<<ENASTB);                        //set ENA/STB enable mode 
	return;
}


void Can_receive(struct MOb *msg)
{
	
	CANPAGE = (msg->mob << MOBNB0);            //select MOb0
	CANIDT4 = (1<<RTRTAG) | (0<<RB0TAG);       // RTR=1 Remote Transmission
	CANIDT3 = 0x00;
	CANIDT2 =((msg->id)&0x7)<<5;               //set Identifier to receive
	CANIDT1 = (msg->id)>>3;   
	CANIDM4=(1<<IDEMSK)|(1<<RTRMSK);           // enable  bit comparaison  
	CANIDM2 = ((msg->msk)&0x7)<<5;             // set IDMask
	CANIDM1 = ((msg->msk)&0x7)<<5; 
	CANCDMOB|=(0<<IDE | 0<<RTRTAG | 8<<DLC0 ); // enable reception and set DATA lenght 
	CANMSG=0x00;
	CANCDMOB|=(1<<CONMOB1);                   // enable transmition 
        wait_for_can_send_finished();
}

//Get index of MOb for which an interrupt was detected.
	
	uint8_t getmob( uint32_t bitmask) 
{
	
	if( bitmask==0) return NOMOB;

 //the bitmask is shifted to the rigth until the LSB is one
 //the number of such shift operations is the index of the MOb
	for( mob=0; (bitmask & 0x01)==0; bitmask >>= 1, ++mob);

 //security check
	if ( mob > 14 ) return NOMOB;
	else return mob;
}




ISR(CANIT_vect)

{
	struct MOb Msg;
	struct MOb *msg;
	msg=&Msg;
	uint8_t cptemp=CANPAGE;   
	if( mob == NOMOB )   return;		                                        
	CANPAGE = mob << 4;	//select concerned MOb page		      
	
	if (CANSTMOB & (1<<TXOK))
	{
		CANSTMOB &= ~(1<<TXOK);	                // clear trasmission mode
		
	}
	else if (CANSTMOB & (1<<RXOK))
	{
			
		for ( int i=0; i<8; i++)
			//get data of selected MOb
		
		{	        
			h_data[i] = CANMSG;
		}
		
		msg->id=0;	 
		msg->id =(CANIDT2<<5); //get identifier which has to be the same like ID
		msg->id |= (CANIDT1>>3);
		can_receive_flag=1;  // mark, that we got an CAN_interrupt, to be handled by main
		CANSTMOB &= ~(1<<RXOK);	 // clear interrupt 	
		CANCDMOB = (1<<CONMOB1); // reset receive
	}
	
	CANPAGE = cptemp;   	// restore CANPAGE
	
}

void wait_for_can_send_finished(void)
{
	
	while (!( CANSTMOB & (1<<TXOK)) ) {
		/* do nothing  */
	}
	CANSTMOB &= ~(1<<TXOK);          //reset flag	
	CANCDMOB &= ~(1<<CONMOB0);      //Deaktivierung
	return;
}
